Index: pjproject/branches/projects/2.0-dev/pjlib/include/pj/errno.h
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/include/pj/errno.h	(revision 3515)
+++ pjproject/branches/projects/2.0-dev/pjlib/include/pj/errno.h	(revision 3516)
@@ -469,4 +469,6 @@
  *  - PJNATH_ERRNO_START	(PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*4)
  *  - PJMEDIA_AUDIODEV_ERRNO_START (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*5)
+ *  - PJ_SSL_ERRNO_START	   (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*6)
+ *  - PJMEDIA_VIDEODEV_ERRNO_START (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*7)
  */
 
Index: pjproject/branches/projects/2.0-dev/pjlib/src/pj/errno.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjlib/src/pj/errno.c	(revision 3515)
+++ pjproject/branches/projects/2.0-dev/pjlib/src/pj/errno.c	(revision 3516)
@@ -34,5 +34,7 @@
 PJ_END_DECL
 
-#define PJLIB_MAX_ERR_MSG_HANDLER   8
+#ifndef PJLIB_MAX_ERR_MSG_HANDLER
+#	define PJLIB_MAX_ERR_MSG_HANDLER   10
+#endif
 
 /* Error message handler. */
Index: pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/errno.h
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/errno.h	(revision 3515)
+++ pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/errno.h	(revision 3516)
@@ -41,8 +41,8 @@
 /**
  * Start of error code relative to PJ_ERRNO_START_USER.
- * This value is 470000.
+ * This value is 520000.
  */
 #define PJMEDIA_VIDEODEV_ERRNO_START \
-	    (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*6)
+	    (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*7)
 #define PJMEDIA_VIDEODEV_ERRNO_END   \
 	    (PJMEDIA_VIDEODEV_ERRNO_START + PJ_ERRNO_SPACE_SIZE - 1)
@@ -56,5 +56,5 @@
  * General/unknown error.
  */
-#define PJMEDIA_EVID_ERR	(PJMEDIA_VIDEODEV_ERRNO_START+1) /* 470001 */
+#define PJMEDIA_EVID_ERR	(PJMEDIA_VIDEODEV_ERRNO_START+1) /* 520001 */
 
 /**
@@ -62,5 +62,5 @@
  * Unknown error from video driver
  */
-#define PJMEDIA_EVID_SYSERR	(PJMEDIA_VIDEODEV_ERRNO_START+2) /* 470002 */
+#define PJMEDIA_EVID_SYSERR	(PJMEDIA_VIDEODEV_ERRNO_START+2) /* 520002 */
 
 /**
@@ -68,5 +68,5 @@
  * Video subsystem not initialized
  */
-#define PJMEDIA_EVID_INIT	(PJMEDIA_VIDEODEV_ERRNO_START+3) /* 470003 */
+#define PJMEDIA_EVID_INIT	(PJMEDIA_VIDEODEV_ERRNO_START+3) /* 520003 */
 
 /**
@@ -74,5 +74,5 @@
  * Invalid video device
  */
-#define PJMEDIA_EVID_INVDEV	(PJMEDIA_VIDEODEV_ERRNO_START+4) /* 470004 */
+#define PJMEDIA_EVID_INVDEV	(PJMEDIA_VIDEODEV_ERRNO_START+4) /* 520004 */
 
 /**
@@ -80,5 +80,5 @@
  * Found no devices
  */
-#define PJMEDIA_EVID_NODEV	(PJMEDIA_VIDEODEV_ERRNO_START+5) /* 470005 */
+#define PJMEDIA_EVID_NODEV	(PJMEDIA_VIDEODEV_ERRNO_START+5) /* 520005 */
 
 /**
@@ -86,5 +86,5 @@
  * Unable to find default device
  */
-#define PJMEDIA_EVID_NODEFDEV	(PJMEDIA_VIDEODEV_ERRNO_START+6) /* 470006 */
+#define PJMEDIA_EVID_NODEFDEV	(PJMEDIA_VIDEODEV_ERRNO_START+6) /* 520006 */
 
 /**
@@ -92,5 +92,5 @@
  * Device not ready
  */
-#define PJMEDIA_EVID_NOTREADY	(PJMEDIA_VIDEODEV_ERRNO_START+7) /* 470007 */
+#define PJMEDIA_EVID_NOTREADY	(PJMEDIA_VIDEODEV_ERRNO_START+7) /* 520007 */
 
 /**
@@ -98,5 +98,5 @@
  * The video capability is invalid or not supported
  */
-#define PJMEDIA_EVID_INVCAP	(PJMEDIA_VIDEODEV_ERRNO_START+8) /* 470008 */
+#define PJMEDIA_EVID_INVCAP	(PJMEDIA_VIDEODEV_ERRNO_START+8) /* 520008 */
 
 /**
@@ -104,5 +104,5 @@
  * The operation is invalid or not supported
  */
-#define PJMEDIA_EVID_INVOP	(PJMEDIA_VIDEODEV_ERRNO_START+9) /* 470009 */
+#define PJMEDIA_EVID_INVOP	(PJMEDIA_VIDEODEV_ERRNO_START+9) /* 520009 */
 
 /**
@@ -110,5 +110,5 @@
  * Bad or invalid video device format
  */
-#define PJMEDIA_EVID_BADFORMAT	(PJMEDIA_VIDEODEV_ERRNO_START+10) /* 4700010 */
+#define PJMEDIA_EVID_BADFORMAT	(PJMEDIA_VIDEODEV_ERRNO_START+10) /* 520010 */
 
 /**
@@ -116,5 +116,5 @@
  * Invalid video device sample format
  */
-#define PJMEDIA_EVID_SAMPFORMAT	(PJMEDIA_VIDEODEV_ERRNO_START+11) /* 4700011 */
+#define PJMEDIA_EVID_SAMPFORMAT	(PJMEDIA_VIDEODEV_ERRNO_START+11) /* 520011 */
 
 /**
@@ -122,5 +122,5 @@
  * Bad latency setting
  */
-#define PJMEDIA_EVID_BADLATENCY	(PJMEDIA_VIDEODEV_ERRNO_START+12) /* 4700012 */
+#define PJMEDIA_EVID_BADLATENCY	(PJMEDIA_VIDEODEV_ERRNO_START+12) /* 520012 */
 
 /**
@@ -128,5 +128,5 @@
  * Bad/unsupported video size
  */
-#define PJMEDIA_EVID_BADSIZE	(PJMEDIA_VIDEODEV_ERRNO_START+13) /* 4700013 */
+#define PJMEDIA_EVID_BADSIZE	(PJMEDIA_VIDEODEV_ERRNO_START+13) /* 520013 */
 
 